// TestDoc.h : interface of the CTestDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TESTDOC_H__238A7E37_6F63_11D3_A4E3_000000000000__INCLUDED_)
#define AFX_TESTDOC_H__238A7E37_6F63_11D3_A4E3_000000000000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Graph2D.h"			//   DLL

extern "C" __declspec(dllimport)
double Aperiodic(double, TData*);

extern "C" __declspec(dllimport)
double Oscillating(double, TData*);

extern "C" __declspec(dllimport)
double Gauss(double, TData*);

extern "C" __declspec(dllimport)
double Poisson (double, TData*);

	//    ,  
	//      
typedef double (*TFunc)(double, TData*);

class CTestDoc : public CDocument
{
protected: // create from serialization only
	CTestDoc();
	DECLARE_DYNCREATE(CTestDoc)

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	//}}AFX_VIRTUAL

// Implementation
public:
	TValues xGr, yGr;		//    
	UINT NPoints;			//  
	TFunc pFunc[4];			//    
	TFunc pCurFunc;			//   () 
	CString sFunc[4];		//    
	CString sCurFunc;		//    
	double Time;			//    X
	UINT nFunc;				//   (==4)
	TData data;				//   
	void Calc();			//   Y (X)

	virtual ~CTestDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CTestDoc)
	afx_msg void OnEditFunction();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
// CFuncDlg

								//      
class CFuncDlg : public CDialog
{
public:
	CFuncDlg(CTestDoc*,TData&);	//    
	CTestDoc* pDoc;				//    
	TData& data;				// ,   
protected:						//    
	virtual void DoDataExchange(CDataExchange* pDX);
	virtual BOOL OnInitDialog();
	afx_msg void OnParm();		//    Parameters
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// COscDlg

class COscDlg : public CDialog
{						// ,     
public:
	CFuncDlg *pDlg;		//  ,   
	COscDlg(CFuncDlg*);	//    
protected:
	virtual void DoDataExchange(CDataExchange* pDX);
};

/////////////////////////////////////////////////////////////////////////////
// CAperDlg

class CAperDlg : public CDialog
{
public:
	CFuncDlg *pDlg;
	CAperDlg(CFuncDlg*);
protected:
	virtual void DoDataExchange(CDataExchange* pDX);
};

/////////////////////////////////////////////////////////////////////////////
// CGaussDlg

class CGaussDlg : public CDialog
{
public:
	CFuncDlg *pDlg;
	CGaussDlg(CFuncDlg*);
protected:
	virtual void DoDataExchange(CDataExchange* pDX);
};

/////////////////////////////////////////////////////////////////////////////
// CPoisDlg

class CPoisDlg : public CDialog
{
public:
	CFuncDlg *pDlg;
	CPoisDlg(CFuncDlg*);
protected:
	virtual void DoDataExchange(CDataExchange* pDX);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTDOC_H__238A7E37_6F63_11D3_A4E3_000000000000__INCLUDED_)
