// TestView.cpp : implementation of the CTestView class
//

#include "stdafx.h"
#include "Test.h"

#include "TestDoc.h"
#include "TestView.h"

#include "Graph2D.h"			//   DLL

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestView

IMPLEMENT_DYNCREATE(CTestView, CView)

BEGIN_MESSAGE_MAP(CTestView, CView)
	//{{AFX_MSG_MAP(CTestView)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestView construction/destruction

CTestView::CTestView():			//  
	BlackPen(PS_SOLID,1,RGB(0,0,0)), 
	BluePen (PS_SOLID,2,RGB(0,0,255)) 
{}

CTestView::~CTestView()
{
}

BOOL CTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTestView drawing

void CTestView::OnDraw(CDC* pDC)
{
	CTestDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
											//   
	pDoc->Calc();
											//   
	UINT size = (pDoc->xGr).GetSize();
	CRect r;
	GetClientRect(r);			//    
							//    
	CGraph graph(r, size);
							//   ,  
	CPen* pOldPen = pDC->SelectObject (&BlackPen);
											//    
	CString Xlab("t"), Ylab("y");
											//   
	graph.DrawGrid (pDC, pDoc->sCurFunc,
								Xlab,Ylab, pDoc->xGr, pDoc->yGr);
							//   Windows   
	BlackPen.Detach();
											//   
	pDC->SelectObject (&BluePen);
											//    
	graph.DrawFunc (pDC);
											//   Windows
	pDC->SelectObject (pOldPen);
}

/////////////////////////////////////////////////////////////////////////////
// CTestView diagnostics

#ifdef _DEBUG
void CTestView::AssertValid() const
{
	CView::AssertValid();
}

void CTestView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CTestDoc* CTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTestDoc)));
	return (CTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTestView message handlers

void CTestView::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo)
{
	CView::OnPrepareDC(pDC, pInfo);	//   
									//    
	pDC->SetMapMode(MM_ANISOTROPIC);
									//   
	pDC->SetWindowExt(100,100);
									//   
	pDC->SetViewportExt(pDC->GetDeviceCaps(LOGPIXELSX),
						pDC->GetDeviceCaps(LOGPIXELSY));
}
